(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('moment'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('angular2-moment-picker', ['exports', '@angular/core', '@angular/common', 'moment', '@angular/forms'], factory) :
    (global = global || self, factory(global['angular2-moment-picker'] = {}, global.ng.core, global.ng.common, global.moment$2, global.ng.forms));
}(this, function (exports, core, common, moment$2, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var moment = moment$2;
    var Angular2MomentPickerService = /** @class */ (function () {
        function Angular2MomentPickerService() {
            this.moment = moment()
                .set('minute', 0)
                .set('seconds', 0);
            this.yearsFormat = 'YYYY';
            this.monthsFormat = 'MMM';
            this.daysFormat = 'D';
            this.hoursFormat = 'HH:[00]';
            this.hoursStart = 0;
            this.minutesStep = 5;
            this.minutesStart = 0;
            this.minutesEnd = 59;
            this.secondsFormat = 'ss';
            this.secondsStep = 1;
            this.secondsStart = 0;
            this.secondsEnd = 59;
        }
        Angular2MomentPickerService.decorators = [
            { type: core.Injectable }
        ];
        return Angular2MomentPickerService;
    }());
    if (false) {
        /** @type {?} */
        Angular2MomentPickerService.prototype.moment;
        /** @type {?} */
        Angular2MomentPickerService.prototype.locale;
        /** @type {?} */
        Angular2MomentPickerService.prototype.format;
        /** @type {?} */
        Angular2MomentPickerService.prototype.yearsFormat;
        /** @type {?} */
        Angular2MomentPickerService.prototype.monthsFormat;
        /** @type {?} */
        Angular2MomentPickerService.prototype.daysFormat;
        /** @type {?} */
        Angular2MomentPickerService.prototype.hoursFormat;
        /** @type {?} */
        Angular2MomentPickerService.prototype.hoursStart;
        /** @type {?} */
        Angular2MomentPickerService.prototype.minutesFormat;
        /** @type {?} */
        Angular2MomentPickerService.prototype.minutesStep;
        /** @type {?} */
        Angular2MomentPickerService.prototype.minutesStart;
        /** @type {?} */
        Angular2MomentPickerService.prototype.minutesEnd;
        /** @type {?} */
        Angular2MomentPickerService.prototype.secondsFormat;
        /** @type {?} */
        Angular2MomentPickerService.prototype.secondsStep;
        /** @type {?} */
        Angular2MomentPickerService.prototype.secondsStart;
        /** @type {?} */
        Angular2MomentPickerService.prototype.secondsEnd;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var ViewState = {
        Decade: 0,
        Year: 1,
        Month: 2,
        Date: 3,
        Hour: 4,
        Minute: 5,
    };
    ViewState[ViewState.Decade] = 'Decade';
    ViewState[ViewState.Year] = 'Year';
    ViewState[ViewState.Month] = 'Month';
    ViewState[ViewState.Date] = 'Date';
    ViewState[ViewState.Hour] = 'Hour';
    ViewState[ViewState.Minute] = 'Minute';
    /** @type {?} */
    var moment$1 = moment$2;
    var Angular2MomentPickerComponent = /** @class */ (function () {
        function Angular2MomentPickerComponent(globals) {
            this.globals = globals;
            this.locale = 'en-us';
            this.onlyupdateatend = false;
            this.changed = new core.EventEmitter();
            this.viewStates = ViewState;
            this.currentView = ViewState.Decade;
            this.open = false;
            this.isFocusInsideComponent = false;
            this.isComponentClicked = false;
        }
        /**
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (!this.moment) {
                this.moment = moment$1();
            }
            this.globals.locale = this.locale;
            if (this.moment) {
                this.globals.moment = this.moment;
            }
            this.viewStack = this.buildViewStack();
        };
        /**
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.click = /**
         * @return {?}
         */
        function () {
            this.isFocusInsideComponent = true;
            this.isComponentClicked = true;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.onOutsideClick = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (!this.isFocusInsideComponent && this.isComponentClicked) {
                this.hide();
                this.isComponentClicked = false;
            }
            this.isFocusInsideComponent = false;
        };
        /**
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.toggle = /**
         * @return {?}
         */
        function () {
            this.isFocusInsideComponent = true;
            this.isComponentClicked = true;
            if (this.startview) {
                this.setCurrentView(this.viewStateFromString(this.startview));
            }
            else if (this.minview) {
                this.setCurrentView(this.viewStateFromString(this.minview));
            }
            else {
                this.setCurrentView(ViewState.Decade);
            }
            this.open = !this.open;
        };
        /**
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.next = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var currentViewIndex = this.viewStack.indexOf(this.currentView);
            if (currentViewIndex === this.viewStack.length) {
                this.hide();
            }
            else {
                this.setCurrentView(this.viewStack[currentViewIndex + 1]);
            }
        };
        /**
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.previous = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var currentViewIndex = this.viewStack.indexOf(this.currentView);
            if (currentViewIndex === 0) {
                return;
            }
            else {
                this.setCurrentView(this.viewStack[currentViewIndex - 1]);
            }
        };
        /**
         * @private
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.buildViewStack = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var stack = [];
            /** @type {?} */
            var min = this.minview ? this.viewStateFromString(this.minview) : ViewState.Decade;
            /** @type {?} */
            var max = this.maxview ? this.viewStateFromString(this.maxview) : ViewState.Minute;
            for (var i = min; i <= max; i++) {
                stack.push(i);
            }
            return stack;
        };
        /**
         * @private
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.hide = /**
         * @private
         * @return {?}
         */
        function () {
            this.open = false;
        };
        /**
         * @private
         * @param {?} view
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.setCurrentView = /**
         * @private
         * @param {?} view
         * @return {?}
         */
        function (view) {
            this.currentView = view;
            this.viewChanged();
        };
        /**
         * @private
         * @param {?} view
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.viewStateFromString = /**
         * @private
         * @param {?} view
         * @return {?}
         */
        function (view) {
            switch (view) {
                case 'decade':
                    return ViewState.Decade;
                case 'year':
                    return ViewState.Year;
                case 'month':
                    return ViewState.Month;
                case 'date':
                    return ViewState.Date;
                case 'hour':
                    return ViewState.Hour;
                case 'minute':
                    return ViewState.Minute;
                default:
                    return ViewState.Decade;
            }
        };
        /**
         * @private
         * @return {?}
         */
        Angular2MomentPickerComponent.prototype.viewChanged = /**
         * @private
         * @return {?}
         */
        function () {
            this.moment = this.globals.moment.clone();
            if (!this.onlyupdateatend) {
                this.changed.emit(this.moment);
            }
            else if (this.onlyupdateatend && !this.currentView) {
                this.changed.emit(this.moment);
            }
        };
        Angular2MomentPickerComponent.decorators = [
            { type: core.Component, args: [{
                        // tslint:disable-next-line: component-selector
                        selector: 'angular2-moment-picker',
                        template: "<div *ngIf=\"open\">\n  <lib-decade-component\n    *ngIf=\"currentView === viewStates.Decade\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  ></lib-decade-component>\n  <lib-year-component\n    *ngIf=\"currentView === viewStates.Year\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  >\n  </lib-year-component>\n  <lib-month-component\n    *ngIf=\"currentView === viewStates.Month\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  >\n  </lib-month-component>\n  <lib-date-component\n    *ngIf=\"currentView === viewStates.Date\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  >\n  </lib-date-component>\n  <lib-hour-component\n    *ngIf=\"currentView === viewStates.Hour\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  >\n  </lib-hour-component>\n  <lib-minute-component\n    *ngIf=\"currentView === viewStates.Minute\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  ></lib-minute-component>\n</div>\n",
                        providers: [Angular2MomentPickerService]
                    }] }
        ];
        /** @nocollapse */
        Angular2MomentPickerComponent.ctorParameters = function () { return [
            { type: Angular2MomentPickerService }
        ]; };
        Angular2MomentPickerComponent.propDecorators = {
            locale: [{ type: core.Input }],
            minview: [{ type: core.Input }],
            maxview: [{ type: core.Input }],
            maxdate: [{ type: core.Input }],
            startview: [{ type: core.Input }],
            onlyupdateatend: [{ type: core.Input }],
            moment: [{ type: core.Input }],
            changed: [{ type: core.Output }],
            click: [{ type: core.HostListener, args: ['click',] }],
            onOutsideClick: [{ type: core.HostListener, args: ['document:click', ['$event'],] }]
        };
        return Angular2MomentPickerComponent;
    }());
    if (false) {
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.locale;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.minview;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.maxview;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.maxdate;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.startview;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.onlyupdateatend;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.moment;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.changed;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.viewStates;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.currentView;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.viewStack;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.open;
        /**
         * @type {?}
         * @private
         */
        Angular2MomentPickerComponent.prototype.isFocusInsideComponent;
        /**
         * @type {?}
         * @private
         */
        Angular2MomentPickerComponent.prototype.isComponentClicked;
        /** @type {?} */
        Angular2MomentPickerComponent.prototype.globals;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BaseComponent = /** @class */ (function () {
        function BaseComponent(globals) {
            this.globals = globals;
            this.perLine = 4;
            this.rows = [];
            this.selectEmitter = new core.EventEmitter();
            this.titleEmitter = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        BaseComponent.prototype.leftArrow = /**
         * @return {?}
         */
        function () {
            this.globals.moment.subtract(1, this.type);
            this.reset();
        };
        /**
         * @return {?}
         */
        BaseComponent.prototype.rightArrow = /**
         * @return {?}
         */
        function () {
            this.globals.moment.add(1, this.type);
            this.reset();
        };
        /**
         * @return {?}
         */
        BaseComponent.prototype.reset = /**
         * @return {?}
         */
        function () {
            this.rows = [];
            this.render();
        };
        /**
         * @return {?}
         */
        BaseComponent.prototype.render = /**
         * @return {?}
         */
        function () {
            return;
        };
        /**
         * @return {?}
         */
        BaseComponent.prototype.title = /**
         * @return {?}
         */
        function () {
            return '';
        };
        /**
         * @return {?}
         */
        BaseComponent.prototype.titleSelected = /**
         * @return {?}
         */
        function () {
            this.titleEmitter.emit();
        };
        /**
         * @param {?} item
         * @return {?}
         */
        BaseComponent.prototype.select = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            return;
        };
        BaseComponent.decorators = [
            { type: core.Component, args: [{
                        template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n"
                    }] }
        ];
        /** @nocollapse */
        BaseComponent.ctorParameters = function () { return [
            { type: Angular2MomentPickerService }
        ]; };
        BaseComponent.propDecorators = {
            selectEmitter: [{ type: core.Output }],
            titleEmitter: [{ type: core.Output }]
        };
        return BaseComponent;
    }());
    if (false) {
        /** @type {?} */
        BaseComponent.prototype.perLine;
        /** @type {?} */
        BaseComponent.prototype.type;
        /** @type {?} */
        BaseComponent.prototype.rows;
        /** @type {?} */
        BaseComponent.prototype.localMoment;
        /** @type {?} */
        BaseComponent.prototype.selectEmitter;
        /** @type {?} */
        BaseComponent.prototype.titleEmitter;
        /** @type {?} */
        BaseComponent.prototype.globals;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HourComponent = /** @class */ (function (_super) {
        __extends(HourComponent, _super);
        function HourComponent(globals) {
            var _this = _super.call(this, globals) || this;
            _this.globals = globals;
            _this.type = 'hour';
            return _this;
        }
        /**
         * @return {?}
         */
        HourComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.render();
        };
        /**
         * @return {?}
         */
        HourComponent.prototype.render = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var i = 0;
            /** @type {?} */
            var minute = this.globals.moment.clone().startOf('hour').minute(0);
            /** @type {?} */
            var minutesFormat = this.globals.minutesFormat ||
                moment$2.localeData(this.globals.locale).longDateFormat('LT').replace(/[aA]/, '').trim();
            for (var m = 0; m < 60; m += this.globals.minutesStep) {
                /** @type {?} */
                var index = Math.floor(i / this.perLine);
                /** @type {?} */
                var isSelectable = true;
                if (!this.rows[index]) {
                    this.rows[index] = [];
                }
                this.rows[index].push({
                    year: minute.year(),
                    month: minute.month(),
                    date: minute.date(),
                    hourr: minute.hour(),
                    minute: minute.minute(),
                    label: minute.format(minutesFormat),
                    selectable: isSelectable,
                    class: [
                        minute.isSame(this.globals.moment, 'minute') ? 'selected' : '',
                    ]
                });
                i++;
                minute.add(this.globals.minutesStep, 'minutes');
            }
        };
        /**
         * @param {?} item
         * @return {?}
         */
        HourComponent.prototype.select = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.globals.moment.set('minute', item.minute);
            this.selectEmitter.emit();
        };
        /**
         * @return {?}
         */
        HourComponent.prototype.title = /**
         * @return {?}
         */
        function () {
            return this.globals.moment.clone().startOf('hour').format('lll');
        };
        HourComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-hour-component',
                        template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                        styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
                    }] }
        ];
        /** @nocollapse */
        HourComponent.ctorParameters = function () { return [
            { type: Angular2MomentPickerService }
        ]; };
        return HourComponent;
    }(BaseComponent));
    if (false) {
        /** @type {?} */
        HourComponent.prototype.type;
        /** @type {?} */
        HourComponent.prototype.globals;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DateComponent = /** @class */ (function (_super) {
        __extends(DateComponent, _super);
        function DateComponent(globals) {
            var _this = _super.call(this, globals) || this;
            _this.globals = globals;
            _this.type = 'day';
            _this.selectEmitter = new core.EventEmitter();
            return _this;
        }
        /**
         * @return {?}
         */
        DateComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.render();
        };
        /**
         * @return {?}
         */
        DateComponent.prototype.render = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var hour = this.globals.moment.clone().startOf('day').hour(this.globals.hoursStart);
            for (var h = 0; h <= 23; h++) {
                /** @type {?} */
                var index = Math.floor(h / this.perLine);
                /** @type {?} */
                var isSelectable = true;
                if (!this.rows[index]) {
                    this.rows[index] = [];
                }
                this.rows[index].push({
                    year: hour.year(),
                    month: hour.month(),
                    date: hour.date(),
                    hour: hour.hour(),
                    minute: hour.minute(),
                    label: hour.format(this.globals.hoursFormat),
                    selectable: isSelectable,
                    class: [
                        hour.isSame(this.globals.moment, 'hour') ? 'selected' : '',
                    ]
                });
                hour.add(1, 'hours');
            }
        };
        /**
         * @param {?} item
         * @return {?}
         */
        DateComponent.prototype.select = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.globals.moment.set('hour', item.hour).startOf('minute').set('minutes', 0).set('seconds', 0);
            this.selectEmitter.emit();
        };
        /**
         * @return {?}
         */
        DateComponent.prototype.title = /**
         * @return {?}
         */
        function () {
            return this.globals.moment.format('LL');
        };
        DateComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-date-component',
                        template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                        styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
                    }] }
        ];
        /** @nocollapse */
        DateComponent.ctorParameters = function () { return [
            { type: Angular2MomentPickerService }
        ]; };
        DateComponent.propDecorators = {
            selectEmitter: [{ type: core.Output }]
        };
        return DateComponent;
    }(BaseComponent));
    if (false) {
        /** @type {?} */
        DateComponent.prototype.type;
        /** @type {?} */
        DateComponent.prototype.selectEmitter;
        /** @type {?} */
        DateComponent.prototype.globals;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MonthComponent = /** @class */ (function (_super) {
        __extends(MonthComponent, _super);
        function MonthComponent(globals) {
            var _this = _super.call(this, globals) || this;
            _this.globals = globals;
            _this.perLine = moment$2.weekdays().length;
            _this.type = 'month';
            _this.selectEmitter = new core.EventEmitter();
            return _this;
        }
        /**
         * @return {?}
         */
        MonthComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.render();
        };
        /**
         * @return {?}
         */
        MonthComponent.prototype.render = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var month = this.globals.moment.month();
            /** @type {?} */
            var isSelectable = true;
            /** @type {?} */
            var day = this.globals.moment.clone().startOf('month').startOf('week').hour(12);
            /** @type {?} */
            var firstWeek = day.week();
            /** @type {?} */
            var lastWeek = firstWeek + 5;
            for (var week = firstWeek; week <= lastWeek; week++) {
                this.rows[week] = Array.apply(null, Array(this.perLine)).map((/**
                 * @return {?}
                 */
                function () {
                    /** @type {?} */
                    var date = {
                        year: day.year(),
                        month: day.month(),
                        date: day.date(),
                        hour: day.hour(),
                        minute: day.minute(),
                        label: day.format(_this.globals.daysFormat),
                        selectable: isSelectable,
                        class: [
                            day.isSame(_this.globals.moment, 'day') ? 'selected' : '',
                            !isSelectable || day.month() !== month ? 'disabled' : ''
                        ]
                    };
                    day.add(1, 'days');
                    return date;
                }));
            }
        };
        /**
         * @param {?} item
         * @return {?}
         */
        MonthComponent.prototype.select = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.globals.moment.set('date', item.date);
            this.selectEmitter.emit();
        };
        /**
         * @return {?}
         */
        MonthComponent.prototype.title = /**
         * @return {?}
         */
        function () {
            return this.globals.moment.format('MMMM YYYY');
        };
        MonthComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-month-component',
                        template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                        styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
                    }] }
        ];
        /** @nocollapse */
        MonthComponent.ctorParameters = function () { return [
            { type: Angular2MomentPickerService }
        ]; };
        MonthComponent.propDecorators = {
            selectEmitter: [{ type: core.Output }]
        };
        return MonthComponent;
    }(BaseComponent));
    if (false) {
        /** @type {?} */
        MonthComponent.prototype.perLine;
        /** @type {?} */
        MonthComponent.prototype.type;
        /** @type {?} */
        MonthComponent.prototype.selectEmitter;
        /** @type {?} */
        MonthComponent.prototype.globals;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var YearComponent = /** @class */ (function (_super) {
        __extends(YearComponent, _super);
        function YearComponent(globals) {
            var _this = _super.call(this, globals) || this;
            _this.globals = globals;
            _this.type = 'year';
            return _this;
        }
        /**
         * @return {?}
         */
        YearComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.render();
        };
        /**
         * @return {?}
         */
        YearComponent.prototype.render = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var month = this.globals.moment.clone().startOf('year').clone();
            /** @type {?} */
            var months = moment$2.monthsShort();
            /** @type {?} */
            var isSelectable = true;
            months.forEach((/**
             * @param {?} label
             * @param {?} i
             * @return {?}
             */
            function (label, i) {
                /** @type {?} */
                var index = Math.floor(i / _this.perLine);
                if (!_this.rows[index]) {
                    _this.rows[index] = [];
                }
                _this.rows[index].push({
                    year: month.year(),
                    month: month.month(),
                    date: month.date(),
                    hour: month.hour(),
                    minute: month.minute(),
                    label: month.format(_this.globals.monthsFormat),
                    selectable: isSelectable,
                    class: [
                        month.isSame(_this.localMoment, 'month') ? 'selected' : '',
                    ]
                });
                month.add(1, 'months');
            }));
        };
        /**
         * @param {?} item
         * @return {?}
         */
        YearComponent.prototype.select = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.globals.moment.set('month', item.month);
            this.selectEmitter.emit();
        };
        /**
         * @return {?}
         */
        YearComponent.prototype.title = /**
         * @return {?}
         */
        function () {
            return this.globals.moment.format('YYYY');
        };
        YearComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-year-component',
                        template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                        styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
                    }] }
        ];
        /** @nocollapse */
        YearComponent.ctorParameters = function () { return [
            { type: Angular2MomentPickerService }
        ]; };
        return YearComponent;
    }(BaseComponent));
    if (false) {
        /** @type {?} */
        YearComponent.prototype.type;
        /** @type {?} */
        YearComponent.prototype.globals;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DecadeComponent = /** @class */ (function (_super) {
        __extends(DecadeComponent, _super);
        function DecadeComponent(globals) {
            var _this = _super.call(this, globals) || this;
            _this.globals = globals;
            return _this;
        }
        /**
         * @return {?}
         */
        DecadeComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.render();
        };
        /**
         * @return {?}
         */
        DecadeComponent.prototype.render = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var year = this.globals.moment.clone();
            /** @type {?} */
            var firstYear = Math.floor(year.year() / 10) * 10 - 1;
            year.year(firstYear);
            for (var y = 0; y < 12; y++) {
                /** @type {?} */
                var index = Math.floor(y / this.perLine);
                /** @type {?} */
                var isSelectable = true;
                if (!this.rows[index]) {
                    this.rows[index] = [];
                }
                this.rows[index].push({
                    year: year.year(),
                    month: year.month(),
                    date: year.date(),
                    hour: year.hour(),
                    minute: year.minute(),
                    label: year.format(this.globals.yearsFormat),
                    selectable: isSelectable,
                    class: [
                        year.isSame(this.globals.moment, 'year') ? 'selected' : '',
                    ]
                });
                year.add(1, 'year');
            }
        };
        /**
         * @return {?}
         */
        DecadeComponent.prototype.leftArrow = /**
         * @return {?}
         */
        function () {
            this.globals.moment.subtract(10, 'years');
            this.reset();
        };
        /**
         * @return {?}
         */
        DecadeComponent.prototype.rightArrow = /**
         * @return {?}
         */
        function () {
            this.globals.moment.add(10, 'years');
            this.reset();
        };
        /**
         * @param {?} item
         * @return {?}
         */
        DecadeComponent.prototype.select = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.globals.moment.set('year', item.year);
            this.selectEmitter.emit();
        };
        /**
         * @return {?}
         */
        DecadeComponent.prototype.title = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var year = this.globals.moment.clone();
            return [year.format('YYYY'), year.subtract(9, 'years').format('YYYY')].reverse().join(' - ');
        };
        DecadeComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-decade-component',
                        template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                        styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
                    }] }
        ];
        /** @nocollapse */
        DecadeComponent.ctorParameters = function () { return [
            { type: Angular2MomentPickerService }
        ]; };
        return DecadeComponent;
    }(BaseComponent));
    if (false) {
        /** @type {?} */
        DecadeComponent.prototype.globals;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MinuteComponent = /** @class */ (function (_super) {
        __extends(MinuteComponent, _super);
        function MinuteComponent(globals) {
            var _this = _super.call(this, globals) || this;
            _this.globals = globals;
            _this.perLine = 6;
            _this.type = 'minute';
            return _this;
        }
        /**
         * @return {?}
         */
        MinuteComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.render();
        };
        /**
         * @return {?}
         */
        MinuteComponent.prototype.render = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var i = 0;
            /** @type {?} */
            var second = this.globals.moment.clone().startOf('minute').second(this.globals.secondsStart);
            for (var s = 0; s <= this.globals.secondsEnd - this.globals.secondsStart; s += this.globals.secondsStep) {
                /** @type {?} */
                var index = Math.floor(i / this.perLine);
                /** @type {?} */
                var isSelectable = true;
                if (!this.rows[index]) {
                    this.rows[index] = [];
                }
                this.rows[index].push({
                    year: second.year(),
                    month: second.month(),
                    date: second.date(),
                    hour: second.hour(),
                    minute: second.minute(),
                    second: second.second(),
                    label: second.format(this.globals.secondsFormat),
                    selectable: isSelectable,
                    class: [
                        second.isSame(this.globals.moment, 'second') ? 'selected' : '',
                    ]
                });
                i++;
                second.add(this.globals.secondsStep, 'seconds');
            }
        };
        /**
         * @param {?} item
         * @return {?}
         */
        MinuteComponent.prototype.select = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.globals.moment.set('seconds', item.second);
            this.selectEmitter.emit();
        };
        /**
         * @return {?}
         */
        MinuteComponent.prototype.title = /**
         * @return {?}
         */
        function () {
            return this.globals.moment.clone().startOf('minute').format('lll');
        };
        MinuteComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-minute-component',
                        template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                        styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
                    }] }
        ];
        /** @nocollapse */
        MinuteComponent.ctorParameters = function () { return [
            { type: Angular2MomentPickerService }
        ]; };
        return MinuteComponent;
    }(BaseComponent));
    if (false) {
        /** @type {?} */
        MinuteComponent.prototype.perLine;
        /** @type {?} */
        MinuteComponent.prototype.type;
        /** @type {?} */
        MinuteComponent.prototype.globals;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Angular2MomentPickerModule = /** @class */ (function () {
        function Angular2MomentPickerModule() {
        }
        Angular2MomentPickerModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            Angular2MomentPickerComponent,
                            BaseComponent,
                            HourComponent,
                            DateComponent,
                            MonthComponent,
                            YearComponent,
                            DecadeComponent,
                            MinuteComponent
                        ],
                        imports: [common.CommonModule, forms.FormsModule],
                        exports: [Angular2MomentPickerComponent],
                        providers: []
                    },] }
        ];
        return Angular2MomentPickerModule;
    }());

    exports.Angular2MomentPickerComponent = Angular2MomentPickerComponent;
    exports.Angular2MomentPickerModule = Angular2MomentPickerModule;
    exports.ɵa = Angular2MomentPickerService;
    exports.ɵb = BaseComponent;
    exports.ɵc = HourComponent;
    exports.ɵd = DateComponent;
    exports.ɵe = MonthComponent;
    exports.ɵf = YearComponent;
    exports.ɵg = DecadeComponent;
    exports.ɵh = MinuteComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular2-moment-picker.umd.js.map
