import { EventEmitter, OnInit } from '@angular/core';
import * as moment_ from 'moment';
import { Angular2MomentPickerService } from './angular2-moment-picker.service';
export declare enum ViewState {
    Decade = 0,
    Year = 1,
    Month = 2,
    Date = 3,
    Hour = 4,
    Minute = 5
}
export declare class Angular2MomentPickerComponent implements OnInit {
    globals: Angular2MomentPickerService;
    locale?: string;
    minview: string;
    maxview: string;
    maxdate?: string;
    startview?: string;
    onlyupdateatend: boolean;
    moment: moment_.Moment;
    changed: EventEmitter<moment_.Moment>;
    viewStates: typeof ViewState;
    currentView: ViewState;
    viewStack: ViewState[];
    open: boolean;
    private isFocusInsideComponent;
    private isComponentClicked;
    constructor(globals: Angular2MomentPickerService);
    ngOnInit(): void;
    click(): void;
    onOutsideClick(event: any): void;
    toggle(): void;
    next(): void;
    previous(): void;
    private buildViewStack;
    private hide;
    private setCurrentView;
    private viewStateFromString;
    private viewChanged;
}
